<?php

declare(strict_types=1);

namespace Drupal\membership_offer\Plugin\Validation\Constraint;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\membership\Entity\MembershipTypeInterface;
use Drupal\membership_offer\MembershipOfferInterface;
use Drupal\membership_offer\Plugin\DirectlyPurchasableMembershipProviderInterface;
use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

final class PriceRequiredConstraintValidator extends ConstraintValidator {

  /**
   * {@inheritDoc}
   */
  public function validate($value, Constraint $constraint) {
    assert($value instanceof FieldItemListInterface);
    $entity = $value->getEntity();
    assert($entity instanceof MembershipOfferInterface);
    $membershipType = $entity->get('membership_type')->first()->entity;
    assert($membershipType instanceof MembershipTypeInterface);
    if (($membershipType->getPlugin() instanceof DirectlyPurchasableMembershipProviderInterface) && $value->filterEmptyItems()->isEmpty()) {
      $this->context->addViolation('Price is required for this provider.');
    }
  }

}
